"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var yargs = require("yargs");
var debug = require("debug");
var argvSplit = require("argv-split");
var spawn_rx_1 = require("spawn-rx");
var TimeoutError_1 = require("rxjs/util/TimeoutError");
require("rxjs/add/operator/publish");
require("rxjs/add/operator/reduce");
require("rxjs/add/operator/timeout");
require("rxjs/add/operator/toPromise");
var d = debug('timeout-cli');
var yargsResult = yargs
    .usage("Usage: timeout-cli -- some-cmd 1 2 3\nExecute a command and exit if it doesn't terminate in a certain amount of time")
    .alias('t', 'timeout')
    .describe('timeout', "is a floating point number with an optional suffix: 's' for\nseconds (the default), 'm' for minutes, 'h' for hours or 'd' for days.")
    .string('timeout')
    .alias('o', 'on-timeout')
    .describe('on-timeout', 'if set, command will be executed when a timeout occurs')
    .string('on-timeout')
    .alias('v', 'version')
    .describe('version', 'Print the current version number and exit')
    .alias('h', 'help');
var argv = yargsResult.argv;
if (argv.version) {
    // tslint:disable-next-line:no-var-requires
    var pkgJson = require('../package.json');
    console.log("timeout-cli " + pkgJson.version);
    process.exit(0);
}
if (argv.help) {
    yargs.showHelp();
    process.exit(0);
}
var multipliers = {
    'm$': 60,
    'h$': 60 * 60,
    'd$': 24 * 60 * 60
};
var numPart = /^[0-9]+(\.[0-9]+)?/;
function parseTime(time) {
    var m = time.match(numPart);
    if (!m || !m[0])
        throw new Error(time + " can't be parsed!");
    var multiplier = Object.keys(multipliers).reduce(function (acc, re) {
        return time.match(new RegExp(re, 'i')) ? multipliers[re] : acc;
    }, 1);
    return parseFloat(m[0]) * multiplier * 1000 /*ms*/;
}
exports.parseTime = parseTime;
function spawnNoisyDetached(cmd, args, opts) {
    var ret = spawn_rx_1.spawnDetached(cmd, args, opts).publish();
    ret.subscribe(function (x) { return console.log(x); }, function (e) { return console.error(e.message); });
    ret.connect();
    return ret.reduce(function () { return undefined; });
}
exports.spawnNoisyDetached = spawnNoisyDetached;
function main(argv, _showHelp) {
    return __awaiter(this, void 0, void 0, function () {
        var processArgs, timeoutTime, e_1, _a, cmd, args;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    processArgs = argv._;
                    timeoutTime = parseTime(argv.timeout || '30s');
                    d("Executing " + processArgs[0] + " and waiting for " + timeoutTime + "ms...");
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    d(JSON.stringify(argv));
                    d(JSON.stringify(processArgs));
                    return [4 /*yield*/, spawnNoisyDetached(processArgs[0], processArgs.slice(1))
                            .timeout(timeoutTime)
                            .toPromise()];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _b.sent();
                    if (e_1 instanceof TimeoutError_1.TimeoutError) {
                        console.error("Process " + processArgs[0] + " timed out after " + timeoutTime + "ms");
                        if (argv['on-timeout']) {
                            _a = argvSplit(argv['on-timeout']), cmd = _a[0], args = _a.slice(1);
                            spawn_rx_1.spawnDetached(cmd, args).subscribe();
                        }
                        return [2 /*return*/, -1];
                    }
                    throw e_1;
                case 4: return [2 /*return*/, 0];
            }
        });
    });
}
exports.main = main;
main(argv, function () { return yargs.showHelp(); })
    .then(function (n) { return process.exit(n); })
    .catch(function (e) {
    console.log("Fatal Error: " + e.message);
    d(e.stack);
    process.exit(-1);
});
//# sourceMappingURL=timeout-cli.js.map